更新履歴
--------


V0.5 L30(2010/3/13)
--------------------
+ フルスクリーン時の画面モード選択に垂直同期周波数の要素を追加
+ フルスクリーン切り替え時の動作モニタ表示メニューの有効化と無効化が
  逆になっていた問題を修正
+ 最小化時はキー入力を拾わないよう変更
+ マウス移動量の取得方法の調整
+ Windows Vista以降の環境で右シフトキーが効くように修正
+ CD-DAのポーズとレジューム処理を修正
+ CDコントローラのステータス応答値の修正
+ CDリピート処理の修正
+ CD入れ替え通知が正常に機能していなかった問題を修正
+ FMR互換画面モードで画面が崩れることがある問題を修正
+ ハードウェア拡大表示の修正
+ パッドに連射機能を追加
+ リコンパイラがi486命令に対応
+ PCM音源のパンポットの初期値を変更
+ 動作クロックの上限値を200MHzに変更
+ その他


V0.5 L20(2010/1/24)
-------------------
+ Windows2000以降の環境におけるCD-DA操作の改善
+ ASPIの使用をWindows9x系の環境のみに制限
+ Windows Vista以降の環境におけるステータスバーの表示の修正
+ Windows Vista以降の環境ではボリュームコントロールを一時的に無効化
+ マウス移動量の取得方法の調整
+ マウス移動感度を水平・垂直個別に設定することに対応
+ プロセスの処理優先順位の変更に対応
+ ウィンドウサイズにユーザ設定サイズを追加
+ リアルタイム動作モニタの追加
+ スプライト描画処理の修正
+ インターバルタイマ2の実装
+ CPUエミュレーションの高速化と再現性向上
+ その他多くの微調整


V0.5 L10a(2007/2/1)
-------------------
+ ハイレゾモード切り替え時にフリーズする不具合を修正
+ ダイナミック・リコンパイラのスケジューリング問題を修正
+ CPUエミュレーションの例外発生時に報告されるエラーコードの誤りを修正
+ VSYNC割り込み、画面描画、CDコントローラ関連の細かい調整
+ インタプリタモードでのステート復元時に一般保護例外が出ることがある問題を
  修正
+ その他


V0.5 L10(2007/1/13)
-------------------
+ CPUエミュレーションの再現性向上
+ スプライト表示速度の互換性向上
+ スプライトのスーパーインポーズビットに対応
+ FM音源タイマレジスタの挙動の修正
+ SCSIコントローラ、FDコントローラ、CDコントローラエミュレーションに対する
  細かい修正多数
+ 画面表示関連の不具合を修正
+ キーボード割り込み処理の改善
+ 画面キャプチャを高速化し、デスクトップの設定に関係なく24ビットのビット
  マップでキャプチャするようにした
+ 画面キャプチャを1/4サイズでできるようにした
+ マウス初期化処理の調整
+ マウスキャプチャ方法について、(1)ホイール操作、(2)中ボタンクリック、
  (3)右ダブルクリックによるキャプチャに対応した
+ マウスホイール操作にキーボードの上下キーを割り当てられるようにした
+ 輝度調整機能を追加した
+ ステータスバーのアイコンデザインを全面的に変更した
+ ステータスバーに、初代TOWNSタイプと2代目TOWNSタイプの音量メータを表示
  できるようにした
+ ステータスバーにHDおよびCDのアクセスランプを追加した
+ タイトルバーの動作比率やFPS値、ステータスバーの表示内容をカスタマイズで
  きるようにした
+ うんづを同時に複数起動できないようにした
+ メニュー項目の整理
+ 内部キーバッファが溢れてハングアップするバグを修正
+ 全体高速になるシステムキーを追加
+ プロパティシート内容の整理と一部機能の廃止
+ 非日本語環境ではダイアログおよびメッセージをほぼ完全に英語で表示するよ
  うになった
+ その他多数の修正


V0.4 L20(2004/5/4)
-------------------
+ ROMEOによるFM音源再生に対応
+ サウンド再生ローパスフィルタを追加
+ 出力先のサウンドデバイスを選択できるようにした
+ 内蔵音源、CD-DA、MIDIそれぞれについて音量を設定できるようにした
+ MIDIエミュレーションを、FMT-401タイプとFMT-402/403タイプとで選択できる
  ようにした
+ ASPI設定時に、認識するデバイスが2機以上ある場合、1機目しか使えないバグ
  を修正
+ CDコントローラエミュレーションの再現性向上
+ ダイナミック・リコンパイラの高速化と安定性向上
+ div,idiv命令エミュレート時のゼロ除算および桁溢れエラーのチェックを、例
  外を拾うことで対処する方法に変更した
+ CPUのみフルスピードで動かす動作モードを追加
+ FMR互換画面時のメモリマップの修正
+ 32ビットカラー時にCHASE H.Q.モードが正常に描画できていなかった問題を修正
+ CHASE H.Q.モード有効時に、他のソフトの画面のパレットが化けることがある問
  題を修正
+ スプライトコントローラのエミュレーションがほぼ正確になった
+ スプライト描画中に保存したステートデータが復元できないことがある問題を
  修正
+ キー押下リセットに CD+N+リセット と F0+N+リセット を追加した
+ ディスクイメージ作成時に「簡易MS-DOSフォーマット」をしたディスクイメージ
  が DiskExplorer で開けない問題を修正
+ FDアクセス速度互換モードを追加
+ ROMイメージの読み込みに失敗して異常終了した場合、CMOS.DATとキー設定がク
  リアされてしまう問題を修正
+ プロパティシートに、全設定をデフォルトに戻すボタンを追加
+ その他


V0.4 L10c(2004/2/8)
--------------------
+ CD入れ替え時にWindowsの自動起動機能の無効化を試みるオプションを追加
+ ダイナミック・リコンパイラの微調整
+ 高解像度モード用VRAMのメモリマップの誤りを修正
+ FM音源の音質をV0.4 L10a以前に戻した


V0.4 L10b(2004/1/19)
---------------------
+ ダイナミック・リコンパイラの高速化と安定性向上
+ シームレスマウスモードが正常に動作しなかった問題を修正
+ アナログスティック入力の修正
+ ALTキーを押すことでプルダウンメニューが起動するようになった(無効設定も可能)
+ プルダウンメニュー操作時にエミュレーションを動作させるか、停止させるか
  選択できるようにした
+ 動作の一時停止中にフルスクリーン/ウィンドウモード切り替えをしたり、ステート
  復元をした場合、一時停止を解除するまで画面が更新されない問題を修正
+ FM音源およびPCM音源をチャネルごとにミュートするデバッグオプションを追加
+ メニューのクロック設定値に「80MHz」、「90MHz」、「100MHz」を追加した


V0.4 L10a(2004/1/3)
--------------------
+ システムキーでマウスキャプチャを行うとWindowsのマウスカーソルの表示・非表示
  切り替えがおかしくなる問題を修正
+ コマンドラインオプションで半角スペースを含んだファイル名が指定できるように
  なった
+ プロパティシートでCD-ROMデバイススキャンに失敗することがある問題を修正
+ 全力駆動時およびエミュレーションが高負担な場合に、プルダウンメニューの反応が
  悪くなる問題へ対処


V0.4 L10(2003/12/31)
---------------------
+ FDフォーマット途中に落ちることがある問題を修正
+ パッドのCOMビットの挙動を修正
+ スプライト動作中にCRTCを操作すると画面の表示位置がずれたままになる問題を
  修正
+ スケジューラを改良し、動作時のCPU使用率を極力下げるようにした
+ ウィンドウ移動時やメニュー操作時に、エミュレーションが停止しないようにした
+ メニューに一時停止オプションを追加
+ 最小化状態からの復帰後、ホイール操作によるマウスキャプチャができなくな
  る問題を修正
+ D88形式のFDイメージをマウントしてリセットすると、FDへアクセスできなくなる
  問題を修正
+ シームレスマウス動作時に、ウィンドウがアクティブでなければマウスの動きを
  捕捉しないようにした
+ ハードディスクイメージ作成時に、4GBまでサイズの指定ができるようになった
+ 画面倍率2倍モードを追加
+ CDボリュームコントロールを無効にするオプションを追加
+ 画面レイアを強制的に非表示にするデバッグオプションを追加
+ Windrv/UNZの共有フォルダ内の日本語ファイル名が化けることがある問題を修正
+ フルスクリーン動作中に別プロセスによって画面が切り替えられると不安定になる
  問題を修正
+ ステート保存・復元に対応
+ ステート復元しながら起動するコマンドラインオプションを追加
+ フルスクリーン状態で起動するコマンドラインオプションを追加
+ コマンドラインオプションが認識されない問題を修正
+ ステータスバーのデザインを一部変更した
+ 日本語以外の動作環境では、英語版プロパティシートが開くようになった
+ その他


V0.3 L20(2003/8/5)
-------------------
+ CPUエミュレーション方式にダイナミック・リコンパイラを導入開始
+ アナログスティックに対応
+ WACOM製タブレットに対応
+ タブレットサポートを利用したシームレスマウスモードを追加
+ パッド・マウスのCOMビットの挙動修正
+ FM音源タイマの挙動修正
+ デジタルパレットレジスタの読み出しができなかった問題を修正
+ キー入力の微調整
+ スナップショットを撮るシステムキーを追加
+ 起動時・終了時におけるウィンドウ位置の保存・復帰が正確に行われていなかった問
  題を修正
+ フルスクリーンモードからウィンドウモードへの復帰時、ウィンドウの位置をフルス
  クリーンモードへ移行する前の位置へ戻すようにした
+ Windrv/UNZ共有フォルダ内のファイルのタイムスタンプがローカル時間になっていな
  かった問題を修正
+ フレームレート6の設定がメニューに反映されなかった問題を修正
+ 640x480・32768色の画面モード時は通常画面モード用の設定に従うようにした
+ その他


V0.3 L10a(2003/7/8)
--------------------
+ 4GB以上のハードディスクイメージに対応
+ PCM再生処理を少し修正
+ サウンドエミュレーションを無音にする設定が保存されなかった問題を修正
+ フルスクリーンの色数設定が保存されなかった問題を修正
+ フルスクリーンモードからウィンドウモードへ戻る時に画面切り替えに失敗すること
  がある問題へ対処
+ 高解像度あるいはフルカラー状態で TownsMENU からソフトリセットを行うと落ちる
  障害を修正
+ キー設定ダイアログの表示の誤りを修正
+ 「半角/全角」「カタカナ/ひらがな」「CapsLock」をキー入力のオートリピート対象
  から外した
+ MARTYエミュレーション時は高解像度・フルカラーモードが無効になるようにした


V0.3 L10(2003/7/5)
---------------------
+ 高解像度・フルカラー画面モードへの対応開始
+ 通常・高解像度・フルカラー表示時それぞれについて、フルスクリーンモード時の解
  像度と色数を個別に設定できるようにした
+ スプライト表示速度を実機並みに落とすオプションを追加(デフォルト設定)
+ 親指シフト同時打鍵判定を改善
+ 親指シフト同時打鍵判定精度を調整するオプションを追加
+ PITの挙動を修正
+ PICの挙動を修正
+ PCM割り込みの挙動を修正
+ beepの挙動を修正
+ パッドI/Oの挙動を修正
+ 2DD(640KB/720KB)および2HD 1.44MBのディスクイメージの作成と読み書きに対応
+ ディスクイメージ作成時にMS-DOSフォーマットされたイメージを作成するオプション
  を追加
+ フロッピーディスクアクセス時のDMA転送精度を高めた
+ CPUエミュレーションの改善(ページフォルト時のエラーコード修正、HLT命令の修正)
+ デスクトップが24bitカラーでも動作可能になった
+ 動作中にデスクトップの解像度や色数の変更があった場合、自動的に追従するように
  なった
+ 特定キー押下状態でのリセット操作に対応
+ 特定キー押下状態でリセットする機能をメニューに追加
+ プロパティシートの一部変更
+ 使用環境によってメニューを日本語/英語切り替えするようにした
+ その他


V0.2 L30b(2003/1/7)
---------------------
+ HDアクセスに失敗することがあるバグを修正
+ ドラッグ＆ドロップによってFDイメージをセットできるようにした


V0.2 L30a(2003/1/6)
---------------------
+ PICのバグを修正
+ メニューの「Notify CD change」の項目を、CD挿入時は「Notify CD change」に、
  非挿入時は「Capture CD」となるようにした


V0.2 L30(2002/12/28)
---------------------
+ 16bitPCMに対応
+ 親指シフトキーボードへの対応を開始
+ 2ストロークによるキー入力が登録可能になった
+ スプライト表示処理の改善
+ CDエミュレーションの一部改善
+ フリーランタイマの進行精度を改善
+ PCM再生処理の再調整
+ 44.1KHz以上のサウンド合成に対応
+ 22.05KHzのサウンド合成を廃止
+ シリアルROMの読み出し値の誤りを修正
+ 画面表示周りの改善
+ VRAM領域を物理アドレス80000000h-80080000hでアクセスした場合と、80100000h-
  80180000hでアクセスした場合との違いを実機に近付けた
+ 画面更新のタイミングを調整し、スクロール中に画面がブレることがある現象を回避
  した
+ ハイカラーのモード判定を自動で行なうようにし、ハイカラーの設定項目を廃止した
+ 水平周波数24KHzの画面モード時のリフレッシュレートを55fpsにした
+ 水平周波数15KHzの画面モード時にスキャンライン表示ができるようになった
+ ハードウェアストレッチモード使用時に一部の画面表示が正常に行なわれないことが
  ある問題を修正
+ 画面領域のサイズを640x480、768x512、1024x512の中から選べるようにし、変則的な
  画面モードやセミハイレゾドライバに対応した
+ フルスクリーン用の解像度を、ビデオカードが対応している画面モードの中から任意
  に選択できるようにした
+ マウス・パッドポートの一時的な入れ換え機能を追加
+ メニューの「Notify CD change」が正常に機能していなかったバグを修正
+ メニューに「Eject CD」の項目を追加し、メニュー上からCDの取り出しができるよう
  になった
+ TownsOS V1.1やMS-DOSからもROMのイメージ化ができるようになった
+ シリアルROMをイメージ化して使えるようになった
+ CPUクロック設定の上限を120MHzに、また搭載メモリの上限を96MBにした
+ Windrv/UNZの若干のバグ修正
+ 高速化
+ その他


V0.2 L20a(2002/10/8)
---------------------
+ MIDI-INを無効にする設定を追加
+ PCMのパンポットが左右逆になっていたバグを修正
+ PCM再生処理の調整
+ SCSIエミュレーションを少し改善
+ PICの挙動を改善
+ 互換/高速モードの判定をTownsOSが誤る問題を修正
+ i80486命令のエミュレーションコードの追加および実装CPUを選択する設定を追加
+ ウィンドウ拡大をした後にフルスクリーン切り替えを行なうと画面表示位置がズレること
  がある問題を修正
+ ビデオカードがハードウェアストレッチに対応していない環境では、画面拡大機能を無効
  にした
+ プロパティシートのCPU設定で、動作クロック設定のスライダーとスピンボタンが連動して
  いなかった問題を修正
+ フレームレートの設定値が保存されないことがある問題を修正
+ Windrv/UNZドライブに表示されるファイルのタイムスタンプを最終更新時刻に変更
+ その他


V0.2 L20(2002/9/29)
---------------------
+ MIDIデバイスを選択可能にした
+ MIDIタイマの改善
+ MIDI-INに対応
+ CD+Gカラオケ再生に対応
+ ビープ音の周波数コントロールが効くようになった
+ 互換モード動作時にCDの読み込み速度を落とす設定を追加
+ スプライト表示停止時の処理を改善
+ ShiftキーとCTRLキーの同時押下が正常に伝えられていなかったバグを修正
+ プリンタを接続状態にした(印刷は行なわれません)
+ BIOSがコプロセッサの有無の判定を誤る問題を修正
+ ICメモリカードが使えなくなっていた問題を修正
+ DirectX 6以前では起動できなくなっていた問題を修正
+ デスクトップが16bppの時に一部のビデオカードで表示が荒れる問題を修正
+ スケジューラの改善
+ フレームレート設定方式を少し変更
+ ウィンドウ拡大表示機能を追加
+ ウィンドウが背面にある時にCPU使用率を抑制する設定を追加
+ CD-DAボリュームコントロールを強制的にモノラルで行なう設定を追加
+ Windrv/UNZへのサポート開始
+ その他


V0.2 L10a(2002/7/13)
----------------------
+ IOCTRLでCDの設定が行われている場合に、CDの入れ替えの認識に失敗することがある
  問題を修正
+ CD-DAボリュームコントロール処理の修正
+ HDD起動で30〜40分程度動作させていると、突然止まる問題(SCSI_SEEK6問題)を修正


V0.2 L10(2002/7/10)
---------------------
+ MARTYのROMに対応 & MARTYエミュレーションモードを追加
+ CD-DAのボリュームコントロールに対応
+ デスクトップが32bitでも動作可能になった(要MMX)
+ 起動時にデスクトップを16bppに自動的に切り替える設定を追加
+ 画面キャプチャ機能を追加
+ DOS512およびEXT区画のハードディスクイメージに対応
+ PITの挙動改善
+ 互換モードとFASTモード用にそれぞれCPUクロック設定ができるようにした
+ PCM再生処理の改善
+ 外字登録処理の再調整
+ ドライブアイコンのアクセスランプの色を指定できるようにした
+ FPSおよび動作速度表示方式の変更
+ その他


V0.1 L40(2002/4/29)
---------------------
+ MIDI再生処理を改善
+ SCSIエミュレーションの改善
+ D88形式のディスクイメージに対応
+ I/Oアクセスによる外字登録に対応
+ 未定義のI/Oの戻り値を0ffhにした
+ SHIFTやCTRLキーが単独で押下された場合に、正常にキーコードが伝えられ
  なかった問題を修正
+ リセット時にHDD接続状態の変更を反映するようにした
+ 動作時はIMEを無効にするようにした
+ WindowsXP環境下でマウスが飛ぶ問題を回避
+ ウィンドウの拡大表示を無効にした
+ 画面描画方式を選択可能にした
+ ウィンドウモード時にフロッピーのアクセスランプを表示できるようにした
+ その他


V0.1 L30(2002/2/11)
---------------------
+ ハードディスク対応
+ FDイメージが書き込み禁止になっているとアクセスに失敗するバグを修正
+ VRAM書き込みマスクに対応
+ 状況によっては漢字表示が化けるバグを修正
+ TownsMENUの終了メニューから「リセット」を選んだ場合、画面にゴミが
  残るバグを修正
+ 画面描画方式の改善
+ ビープ音が鳴るようになった
+ 動作中にCTRL+ALT+DELETEを押すと落ちるバグを修正
+ CD-DA関係の再・再調整
+ エラーメッセージを極力ウィンドウに表示するようにした
+ 20ドット漢字ROMイメージファイルの使用開始
+ その他


V0.1 L20b(2001/12/17)
---------------------
+ ICメモリカードイメージに対応(16MBまで)
+ MIDI対応(アウトプット機能の一部のみ)
+ DirectSoundが使えない環境でも起動可能になった
+ FM音源割り込み処理の改善
+ CD-DA関係の再調整
+ IOCTRLアクセス時にCDの入れ替えを認識できなかったバグを修正
+ 横スクロール時に画面に断層ができる問題を修正
+ 一部の特殊画面モードに対応
+ キー入力をDirectInput仕様にし、割り当て可能なキーの数を増やした
+ システムキー、パッドのエミュレーションキーを自由に設定できるようにした
+ CPUコアのバグ修正
+ その他


V0.1 L20a(2001/11/13)
---------------------
+ CD-DA再生処理の改善
+ CD-DA自動リピート再生に対応
+ PCM音声の再生方法を少し改良
+ ２画面合成モードで、各レイアの描画領域が異なると画面が重ね書きされることが
  ある問題を修正
+ フレームレートの値が正確に反映されていなかったバグを修正
+ ディスクイメージのファイル名に全角文字や空白が含まれていると正常にマウント
  できない問題を修正
+ 代替IPLを用意することにより、一部の特殊フォーマットCDが起動できるようになった
+ SCSIのCD-ROMドライブが複数ある場合、プロパティシートを開くとCD-ROMの設定が
  書き換わってしまうバグを修正
+ その他


V0.1 L20(2001/11/2)
--------------------
+ CD-DA対応
+ CD-ROMの入れ替えを認識できるようになった(自動認識に加え、任意に入れ替えを通知
  することも可能。メニューにCD Changeを追加)
+ CDがドライブに入っていないときにエラーを返すようになった
+ CD読み込みキャッシュの搭載
+ 古いRUN386.EXEに対応(pushfd,popfd命令でIOPLおよびNTビットの反映、xbts命令の回
  避)
+ div,idiv命令で演算オーバーフローが正確に判定できていなかったバグを修正
+ ディスクイメージのファイル名が長いとバグる問題を修正
+ リセット時にキー設定の変更がクリアされるバグを修正
+ FM-VTOWNSのROMでも起動時のロゴが表示されるようになった
+ ６ボタンパッドと２ボタンパッドを使い分けられるようにした
+ フルスピードモード／ウェイトモード切り替え機能を実装
+ オートフレームスキップ機能を実装
+ フレームレート表示機能を追加
+ ホイール操作の取得方法を、DirectInputかWinodwsのメッセージか選択できるように
  した
+ 画面領域外でホイール操作を行った場合にマウスキャプチャがおかしくなることが
  あるバグを修正
+ 高速化
+ その他


V0.1 L10d(2001/9/19)
--------------------
+ フルスクリーンモードを追加
+ Windows2000環境で、IOCTRLによるCDアクセスをサポート
+ コマンドラインの指定によりディスクイメージの挿入ができるようにした
+ TownsMENU上の「電源OFF」の選択によって、うんづも終了するようにした
+ 時計が24時間時計になっていなかったバグを修正
+ その他


V0.1 L10c(2001/9/2)
--------------------
追加
+ 6ボタンパッドに対応
+ DirectDrawのバッファをシステムメモリにも置けるようにした
+ ホイールボタン操作でマウスキャプチャの切り替えができるようにした(Windows95
  環境を除く)
+ 終了時にウィンドウの位置とサイズを記憶するようにした
+ システムメニューにPower Offを追加

修正
+ FM音源割り込み処理の改善
+ ディスクイメージと同じフォルダに一部のシステムファイルが保存されてしまう
  バグを修正
+ リセット時に画面にゴミが残る問題を修正
+ 32768色1レイアの画面モードで、透過ビットがセットされているとピクセルが正
  常に描画されないバグを修正
+ その他


V0.1 L10b(2001/8/27)
--------------------
+ 大部分の機種のROMイメージに対応(したつもり)
+ CRTC設定値によってはWindowsごと落ちるバグを低減
+ 15ﾋﾞｯﾄHighColourモードを追加
+ その他微調整


V0.1 L10a(2001/8/25)
--------------------
+ 一般公開バージョン


V0.1 L10以前
-------------
+ テストバージョン(未公開)

